const io  = require('socket.io')(3555);
const nsp = io.of('/randomFree');

class randomFree {

	constructor() {
		nsp.on('connection', (socket) => {
		  console.log('someone connected');
		  socket.join('queue');
		  this.match();
		});
	}

	match() {
		nsp.in('queue').clients((error, clients) => {
		  	if (error) throw error;
		  
			if(clients.length > 1) {
				let p1 = nsp.sockets[clients[0]];
				let p2 = nsp.sockets[clients[1]];

				const channel = clients[0] + clients[1];

				let err = (e) => {
					if(e)throw e;
					return 0;
				};

				p1.leave('queue', err);
				p1.join(channel, err);
				p2.leave('queue', err);
				p2.join(channel, err);
				// setTimeout(() => {
				// 	console.log("MATCH: " +channel+ " !");
				// 	console.log(Object.keys(nsp.in(channel).sockets));
				// 	console.log("QUEUE!");
				// 	console.log(Object.keys(nsp.in('queue').sockets));
				// }, 5000);
				nsp.in(channel).clients((err, clients) => {
					console.log('Channel: ' + channel);
					console.log(clients);
				});
			}

			nsp.in('queue').clients((err, clients) => {
				console.log('Queue');
				console.log(clients)
			});
		});
	}

    join(user){
        //join randomFree queue room
    }
}

module.exports = new randomFree();